// https://www.plurk.com/API

import 'package:plurdart/src/models/rest/enums.dart';

class UsersUpdate {
  String fullName;
  String email;
  String displayName;
  DateTime dateOfBirth;
  Privacy privacy = Privacy.world;

  UsersUpdate({
    this.fullName,
    this.email,
    this.displayName,
    this.dateOfBirth,
    this.privacy,
  });

  Map<String, String> toBody() {
    final Map<String, String> data = new Map<String, String>();
    if (fullName != null) data['full_name'] = fullName;
    if (email != null) data['email'] = email;
    if (displayName != null) data['display_name'] = displayName;
    if (privacy != null) data['privacy'] = privacy.toString();

    if (dateOfBirth != null) {
      data['date_of_birth'] =
      "${dateOfBirth.year.toString()}-${dateOfBirth.month.toString().padLeft(2, '0')}-${dateOfBirth.day.toString().padLeft(2, '0')}";
    }
    return data;
  }
}
