// https://www.plurk.com/API
import 'package:intl/intl.dart';

import 'base.dart';
import 'anniversary.dart';
import 'filter.dart';
import 'dart:core';

class User extends Base {
  int id;
  int hasProfileImage;
  int timelinePrivacy;
  String nickName;
  String displayName;
  String dateOfBirth;
  int avatar;
  int gender;
  double karma;
  bool premium;
  int enable2fa;
  bool verifiedAccount;
  int dateformat;
  String defaultLang;
  String friendListPrivacy;
  String nameColor;
  String fullName;
  String location;
  String timezone;
  int bdayPrivacy;
  int plurksCount;
  int responseCount;
  int pinnedPlurkId;
  int backgroundId;
  bool showAds;
  int showLocation;
  bool following;
  bool settings;
  int following_tl;
  int following_im;
  int profileViews;
  String avatarSmall;
  String avatarMedium;
  String avatarBig;
  String about;
  String aboutRenderred;
  String pageTitle;
  int recruited;
  String relationship;
  int friendsCount;
  int fansCount;
  String joinDate;
  String privacy;
  String acceptPrivatePlurkFrom;
  bool postAnonymousPlurk;
  List<String> badges;
  bool linkFacebook;
  bool setupFacebookSync;
  bool setupTwitterSync;
  bool setupWeiboSync;
  Filter filter;
  Anniversary anniversary;
  int creature;
  String creatureUrl;
  int creatureSpecial;
  String creatureSpecialUrl;
  String email;
  bool emailConfirmed;
  int uid;

  User(
      {this.id,
        this.hasProfileImage,
        this.timelinePrivacy,
        this.nickName,
        this.displayName,
        this.dateOfBirth,
        this.avatar,
        this.gender,
        this.karma,
        this.premium,
        this.enable2fa,
        this.verifiedAccount,
        this.dateformat,
        this.defaultLang,
        this.friendListPrivacy,
        this.nameColor,
        this.fullName,
        this.location,
        this.timezone,
        this.bdayPrivacy,
        this.plurksCount,
        this.responseCount,
        this.pinnedPlurkId,
        this.backgroundId,
        this.showAds,
        this.showLocation,
        this.following,
        this.settings,
        this.following_tl,
        this.following_im,
        this.profileViews,
        this.avatarSmall,
        this.avatarMedium,
        this.avatarBig,
        this.about,
        this.aboutRenderred,
        this.pageTitle,
        this.recruited,
        this.relationship,
        this.friendsCount,
        this.fansCount,
        this.joinDate,
        this.privacy,
        this.acceptPrivatePlurkFrom,
        this.postAnonymousPlurk,
        this.badges,
        this.linkFacebook,
        this.setupFacebookSync,
        this.setupTwitterSync,
        this.setupWeiboSync,
        this.filter,
        this.anniversary,
        this.creature,
        this.creatureUrl,
        this.creatureSpecial,
        this.creatureSpecialUrl,
        this.email,
        this.emailConfirmed,
        this.uid});

  User.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    hasProfileImage = json['has_profile_image'];
    timelinePrivacy = json['timeline_privacy'];
    nickName = json['nick_name'];
    displayName = json['display_name'];
    dateOfBirth = json['date_of_birth'];
    avatar = json['avatar'];
    gender = json['gender'];
    karma = (json['karma'] is int) ? json['karma'].toDouble() : json['karma'];
    premium = json['premium'];
    enable2fa = json['enable_2fa'];
    verifiedAccount = json['verified_account'];
    dateformat = json['dateformat'];
    defaultLang = json['default_lang'];
    friendListPrivacy = json['friend_list_privacy'];
    nameColor = json['name_color'];
    fullName = json['full_name'];
    location = json['location'];
    timezone = json['timezone'];
    bdayPrivacy = json['bday_privacy'];
    plurksCount = json['plurks_count'];
    responseCount = json['response_count'];
    pinnedPlurkId =
    (json['pinned_plurk_id'] != null) ? json['pinned_plurk_id'] : null;
    backgroundId = json['background_id'];
    showAds = json['show_ads'];
    showLocation = json['show_location'];
    following = json['following'];
    settings = json['settings'];
    following_tl = json['following_tl'];
    following_im = json['following_im'];
    profileViews = json['profile_views'];
    avatarSmall = json['avatar_small'];
    avatarMedium = json['avatar_medium'];
    avatarBig = json['avatar_big'];
    about = json['about'];
    aboutRenderred = json['about_renderred'];
    pageTitle = json['page_title'];
    recruited = json['recruited'];
    relationship = json['relationship'];
    friendsCount = json['friends_count'];
    fansCount = json['fans_count'];
    joinDate = json['join_date'];
    privacy = json['privacy'];
    acceptPrivatePlurkFrom = json['accept_private_plurk_from'];
    postAnonymousPlurk = json['post_anonymous_plurk'];
    if (json['badges'] != null) {
      badges = List<String>();
      List badgeList = json['badges'];
      if (badgeList != null) {
        badgeList.forEach((element) {
          badges.add(element);
        });
      }
    }
    linkFacebook = json['link_facebook'];
    setupFacebookSync = json['setup_facebook_sync'];
    setupTwitterSync = json['setup_twitter_sync'];
    setupWeiboSync = json['setup_weibo_sync'];
    filter =
    json['filter'] != null ? new Filter.fromJson(json['filter']) : null;
    anniversary = json['anniversary'] != null
        ? new Anniversary.fromJson(json['anniversary'])
        : null;
    creature = json['creature'];
    creatureUrl = json['creature_url'];
    creatureSpecial = json['creature_special'];
    creatureSpecialUrl = json['creature_special_url'];
    email = json['email'];
    emailConfirmed = json['email_confirmed'];
    uid = json['uid'];
    errorText = json['error_text'];
    successText = json['success_text'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['has_profile_image'] = this.hasProfileImage;
    data['timeline_privacy'] = this.timelinePrivacy;
    data['nick_name'] = this.nickName;
    data['display_name'] = this.displayName;
    data['date_of_birth'] = this.dateOfBirth;
    data['avatar'] = this.avatar;
    data['gender'] = this.gender;
    data['karma'] = this.karma;
    data['premium'] = this.premium;
    data['enable_2fa'] = this.enable2fa;
    data['verified_account'] = this.verifiedAccount;
    data['dateformat'] = this.dateformat;
    data['default_lang'] = this.defaultLang;
    data['friend_list_privacy'] = this.friendListPrivacy;
    data['name_color'] = this.nameColor;
    data['full_name'] = this.fullName;
    data['location'] = this.location;
    data['timezone'] = this.timezone;
    data['bday_privacy'] = this.bdayPrivacy;
    data['plurks_count'] = this.plurksCount;
    data['response_count'] = this.responseCount;
    data['pinned_plurk_id'] = this.pinnedPlurkId;
    data['background_id'] = this.backgroundId;
    data['show_ads'] = this.showAds;
    data['show_location'] = this.showLocation;
    data['following'] = this.following;
    data['settings'] = this.settings;
    data['following_tl'] = this.following_tl;
    data['following_im'] = this.following_im;
    data['profile_views'] = this.profileViews;
    data['avatar_small'] = this.avatarSmall;
    data['avatar_medium'] = this.avatarMedium;
    data['avatar_big'] = this.avatarBig;
    data['about'] = this.about;
    data['about_renderred'] = this.aboutRenderred;
    data['page_title'] = this.pageTitle;
    data['recruited'] = this.recruited;
    data['relationship'] = this.relationship;
    data['friends_count'] = this.friendsCount;
    data['fans_count'] = this.fansCount;
    data['join_date'] = this.joinDate;
    data['privacy'] = this.privacy;
    data['accept_private_plurk_from'] = this.acceptPrivatePlurkFrom;
    data['post_anonymous_plurk'] = this.postAnonymousPlurk;
    data['badges'] = this.badges;
    data['link_facebook'] = this.linkFacebook;
    data['setup_facebook_sync'] = this.setupFacebookSync;
    data['setup_twitter_sync'] = this.setupTwitterSync;
    data['setup_weibo_sync'] = this.setupWeiboSync;
    if (this.filter != null) {
      data['filter'] = this.filter.toJson();
    }
    if (this.anniversary != null) {
      data['anniversary'] = this.anniversary.toJson();
    }
    data['creature'] = this.creature;
    data['creature_url'] = this.creatureUrl;
    data['creature_special'] = this.creatureSpecial;
    data['creature_special_url'] = this.creatureSpecialUrl;
    data['email'] = this.email;
    data['email_confirmed'] = this.emailConfirmed;
    data['uid'] = this.uid;
    data['error_text'] = this.errorText;
    data['success_text'] = this.successText;
    return data;
  }

  // Convenient APIs for getting User avatar.
  // See https://www.plurk.com/API for User Data explain.

  String smallAvatarUrl() {
    if (hasProfileImage == 1) {
      // This probably for different version compatible.
      if (avatar != null && avatar != 0) {
        return 'https://avatars.plurk.com/'+ id.toString() + '-small' + avatar.toString() + '.gif';
      } else {
        return 'https://avatars.plurk.com/'+ id.toString() + '-small.gif';
      }
    } else {
      // Default avatar by Plurk.
      return 'https://www.plurk.com/static/default_small.gif';
    }
  }

  String mediumAvatarUrl() {
    if (hasProfileImage == 1) {
      // This probably for different version compatible.
      if (avatar != null && avatar != 0) {
        return 'https://avatars.plurk.com/'+ id.toString() + '-medium' + avatar.toString() + '.gif';
      } else {
        return 'https://avatars.plurk.com/'+ id.toString() + '-medium.gif';
      }
    } else {
      // Default avatar by Plurk.
      return 'https://www.plurk.com/static/default_medium.gif';
    }
  }

  String bigAvatarUrl() {
    if (hasProfileImage == 1) {
      // This probably for different version compatible.
      if (avatar != null && avatar != 0) {
        return 'https://avatars.plurk.com/'+ id.toString() + '-big' + avatar.toString() + '.jpg';
      } else {
        return 'https://avatars.plurk.com/'+ id.toString() + '-big.jpg';
      }
    } else {
      // Default avatar by Plurk.
      return 'https://www.plurk.com/static/default_big.gif';
    }
  }

  String genderStr() {
    if (gender == 0) {
      return 'Female';
    } else if (gender == 1) {
      return 'Male';
    } else {
      return 'Not stating/other';
    }
  }

  //Do we have a background?
  bool hasBackground() {
    return (backgroundId != null && backgroundId > 0);
  }

  //Return empty String if no background.
  String backgroundUrl() {
    if (hasBackground()) {
      return 'https://images.plurk.com/bg/' + id.toString() + '-' + backgroundId.toString() + '.jpg';
    }
    return '';
  }

  //Possible null
  DateTime birthDateTime() {
    if (dateOfBirth != null) {
      try {
        return DateFormat('EEE, d MMM yyyy HH:mm:ss vvv')
            .parseUTC(dateOfBirth)
            .toLocal();
      } catch (e) {
        print(e.toString());
        return null;
      }
    }
    return null;
  }

  //Possible null
  DateTime joinDateTime() {
    if (joinDate != null) {
      try {
        return DateFormat('EEE, d MMM yyyy HH:mm:ss vvv')
            .parseUTC(joinDate)
            .toLocal();
      } catch (e) {
        print(e.toString());
        return null;
      }
    }
    return null;
  }

}
